/* Useful helper functions */

function tree_selection(id) {
    var tree = document.getElementById(id);
    var name = tree.columns.getPrimaryColumn();
    var i = tree.currentIndex;
    var path = new Array();
    while (i >= 0) {
	path.splice(0, 0, tree.view.getCellText(i, name));
	i = tree.view.getParentIndex(i);
    }
    return path;
}

function tree_selection_and_check(id) {
    var tree = document.getElementById(id);
    var name = tree.columns.getPrimaryColumn();
    var check = tree.columns.getFirstColumn();
    var i = tree.currentIndex;
    var checked = tree.view.getCellValue(i, check);
    var path = new Array();
    while (i >= 0) {
	path.splice(0, 0, tree.view.getCellText(i, name));
	i = tree.view.getParentIndex(i);
    }
    return [path, checked];
}

/* Functions driving the CherryPy backend */

function new_tag(path) {
    alert('Adding tag: '+path.toString());
    /* https://developer.mozilla.org/en/RDF_in_Mozilla_FAQ */
}

function add_tag(path, tag) {
    alert('Add tag '+tag+' to '+path.toString());
}

function remove_tag(path, tag) {
    alert('Remove tag '+tag+' from '+path.toString());
}

/* The bindings themselves */

function initialize() {
    element = document.getElementById('element').file_path = 'UNDEFINED';
}

function new_tag_button() {
    var text = document.getElementById('new-tag-text').value;
    new_tag(text.split('/'));
}

function set_selected_element(path) {
    element = document.getElementById('element');
    element.file_path = path;
    alert('Set selected element: '+path.toString());
}

function raw_tree_select() {
    set_selected_element(tree_selection('raw-tree'));
}

function tag_tree_select() {
    set_selected_element(tree_selection('tag-tree'));
}

function tag_check(event) {
    var path = document.getElementById('element').file_path;
    var a = tree_selection_and_check('checkbox-tree');
    id = a[0];
    checked = a[1];
    alert('path: '+path.toString());
    alert('id: '+id);
    alert('check: '+checked);
    if (checked) {
	add_tag(path, id);
    } else {
	remove_tag(path, id);
    }
}
